Deleting Tasks in Vue Gantt Chart Component

18 Nov 201824 minutes to read

A task delete option in the Gantt Chart component can be enabled by enabling the editSettings.allowDeleting property. Tasks can be deleted by clicking the delete toolbar item or using the deleteRow method. You can call this method dynamically on any custom actions like button click. The following code example shows how to enable the delete option in the Gantt Chart component.

<template>
     <div>
        <ejs-button id="deleteRecord" cssClass="e-info" v-on:click="update">delete</ejs-button>
        <br><br><br>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height"  :columns = "columns" :editSettings= "editSettings"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { GanttComponent as EjsGantt, Edit, Selection } from "@syncfusion/ej2-vue-gantt";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
const gantt = ref(null);

const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const columns = [
    { field: 'TaskID', headerText: 'Task ID', textAlign: 'Left', width: '100' },
    { field: 'TaskName', headerText: 'Task Name', width: '250' },
    { field: 'StartDate', headerText: 'Start Date', width: '150' },
    { field: 'Duration', headerText: 'Duration', width: '150' },
    { field: 'Progress', headerText: 'Progress', width: '150' },
];
const editSettings = {
    allowDeleting: true,
    showDeleteConfirmDialog: true
};
const update = function(e){
    var ganttObj = gantt.value.ej2Instances;
    ganttObj.editSettings.showDeleteConfirmDialog = true ;
    ganttObj.editModule.deleteRow();
};
provide('gantt',  [ Edit, Selection ]);
</script>
<template>
     <div>
        <ejs-button id="deleteRecord" cssClass="e-info" v-on:click="update">delete</ejs-button>
        <br><br><br>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height"  :columns = "columns" :editSettings= "editSettings"></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Edit, Selection } from "@syncfusion/ej2-vue-gantt";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
export default {
name: "App",
components: {
"ejs-button":ButtonComponent,
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
            columns: [
                { field: 'TaskID', headerText: 'Task ID', textAlign: 'Left', width: '100' },
                { field: 'TaskName', headerText: 'Task Name', width: '250' },
                { field: 'StartDate', headerText: 'Start Date', width: '150' },
                { field: 'Duration', headerText: 'Duration', width: '150' },
                { field: 'Progress', headerText: 'Progress', width: '150' },
            ],
            editSettings: {
                allowDeleting: true,
                showDeleteConfirmDialog: true
            },
      };
  },
  provide: {
      gantt: [ Edit, Selection ]
  },
   methods: {
      update: function(e){
         var ganttObj = document.getElementById('GanttContainer').ej2_instances[0];
         ganttObj.editSettings.showDeleteConfirmDialog = true ;
         ganttObj.editModule.deleteRow();
      },
  }
};
</script>

NOTE: You should select any one of the rows in the Gantt Chart component to perform the task delete action.
You should set the editSettings.allowDeleting value to true to delete the record dynamically.

Delete confirmation message

Delete confirmation message is used to get confirmation from users before deleting a task. This confirmation message can be enabled by setting the editSettings.showDeleteConfirmDialog property to true.

The following code snippet explains how to enable the delete confirmation message in the Gantt Chart.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :toolbar="toolbar" :columns = "columns" :editSettings= "editSettings"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { GanttComponent as EjsGantt, Edit,Selection,Toolbar } from "@syncfusion/ej2-vue-gantt";

const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const columns = [
    { field: 'TaskID', headerText: 'Task ID', textAlign: 'Left', width: '100' },
    { field: 'TaskName', headerText: 'Task Name', width: '250' },
    { field: 'StartDate', headerText: 'Start Date', width: '150' },
    { field: 'Duration', headerText: 'Duration', width: '150' },
    { field: 'Progress', headerText: 'Progress', width: '150' },
];
const toolbar = ['Delete'];
const editSettings = {
    allowDeleting: true,
    showDeleteConfirmDialog: true
};
provide('gantt',  [ Edit,Selection,Toolbar ]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :toolbar="toolbar" :columns = "columns" :editSettings= "editSettings"></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Edit,Selection,Toolbar } from "@syncfusion/ej2-vue-gantt";
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
            columns: [
                { field: 'TaskID', headerText: 'Task ID', textAlign: 'Left', width: '100' },
                { field: 'TaskName', headerText: 'Task Name', width: '250' },
                { field: 'StartDate', headerText: 'Start Date', width: '150' },
                { field: 'Duration', headerText: 'Duration', width: '150' },
                { field: 'Progress', headerText: 'Progress', width: '150' },
            ],
            toolbar: ['Delete'],
            editSettings: {
                allowDeleting: true,
                showDeleteConfirmDialog: true
            },
      };
  },
  provide: {
      gantt: [ Edit,Selection,Toolbar ]
  }
};
</script>

Deleting Tasks in React Gantt Chart Component

18 Nov 201822 minutes to read

Deleting tasks in the React Gantt Chart component streamlines project management by removing tasks, such as outdated milestones or subtasks, using the toolbar or programmatic methods. Enabled by setting the editSettings.allowDeleting property to true and injecting Edit, tasks can be deleted after selecting a row, ensuring seamless updates to dependencies and critical path calculations. A confirmation dialog, activated via editSettings.showDeleteConfirmDialog, prompts to verify deletions, preventing accidental removals. The deleteRow method allows programmatic deletion, requiring a selected row with valid taskFields mappings (e.g., id, name). Ensure tasks are selected and taskFields are properly configured to avoid issues during deletion.

Delete tasks via toolbar

Enable task deletion through the toolbar by setting editSettings.allowDeleting to true and injecting Edit. Select a row and click the toolbar’s Delete icon to remove the task, with an optional confirmation dialog if editSettings.showDeleteConfirmDialog is enabled. This method is ideal for quickly removing tasks like completed activities.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Edit, Selection, Inject, Toolbar } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
    let ganttInstance = null;
    const taskFields = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        endDate: 'EndDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const editSettings = {
        allowDeleting: true,
        showDeleteConfirmDialog: true
    };
    const columns = [
        { field: 'TaskID', headerText: 'Task ID', width: 100 },
        { field: 'TaskName', headerText: 'Task Name', width: 250 },
        { field: 'StartDate', headerText: 'Start Date', width: 150 },
        { field: 'Duration', headerText: 'Duration', width: 150 },
        { field: 'Progress', headerText: 'Progress', width: 150 }
    ];
    const toolbar = ['Delete']

    return (
        <div>
            <GanttComponent
                id="Gantt"
                height="430px"
                dataSource={data}
                taskFields={taskFields}
                editSettings={editSettings}
                columns={columns}
                toolbar={toolbar}
                ref={gantt => ganttInstance = gantt}
            >
                <Inject services={[Edit, Selection, Toolbar]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Edit, Selection, Inject, Toolbar, Columns, TaskFieldsModel, EditSettingsModel } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
    let ganttInstance: GanttComponent | null = null;
    const taskFields: TaskFieldsModel = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        endDate: 'EndDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const editSettings: EditSettingsModel = {
        allowDeleting: true,
        showDeleteConfirmDialog: true
    };
    const columns: Columns[] = [
        { field: 'TaskID', headerText: 'Task ID', width: 100 },
        { field: 'TaskName', headerText: 'Task Name', width: 250 },
        { field: 'StartDate', headerText: 'Start Date', width: 150 },
        { field: 'Duration', headerText: 'Duration', width: 150 },
        { field: 'Progress', headerText: 'Progress', width: 150 }
    ];
    const toolbar: string[] = ['Delete']

    return (
        <div>
            <GanttComponent
                id="Gantt"
                height="430px"
                dataSource={data}
                taskFields={taskFields}
                editSettings={editSettings}
                columns={columns}
                toolbar={toolbar}
                ref={gantt => ganttInstance = gantt}
            >
                <Inject services={[Edit, Selection, Toolbar]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Delete tasks with confirmation dialog

Enable a confirmation dialog for task deletion by setting editSettings.showDeleteConfirmDialog to true, alongside editSettings.allowDeleting and Edit service. After selecting a row, deleting via the toolbar or deleteRow method prompts a dialog to confirm the action, ensuring intentional removals. This is useful for critical tasks where accidental deletion must be avoided.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Edit, Selection, Toolbar, Inject } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
    const taskFields = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        endDate: 'EndDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };

    const columns = [
        { field: 'TaskID', headerText: 'Task ID', width: 100 },
        { field: 'TaskName', headerText: 'Task Name', width: 250 },
        { field: 'StartDate', headerText: 'Start Date', width: 150 },
        { field: 'Duration', headerText: 'Duration', width: 150 },
        { field: 'Progress', headerText: 'Progress', width: 150 }],

    const editSettings = {
        allowDeleting: true,
        showDeleteConfirmDialog: true
    };

    const toolbar = ['Delete'];

    return (
        <GanttComponent
            id="Gantt"
            height="430px"
            dataSource={data}
            taskFields={taskFields}
            columns={columns}
            editSettings={editSettings}
            toolbar={toolbar}
        >
            <Inject services={[Edit, Selection, Toolbar]} />
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Edit, EditSettingsModel,Selection, Toolbar, ToolbarItem } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';
function App(){
    const  taskFields: any = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };
  const editOptions: EditSettingsModel = {
      allowDeleting: true,
      showDeleteConfirmDialog: true
  };
  const toolbar: ToolbarItem[] = ['Delete'];
        return <GanttComponent dataSource={data} taskFields={taskFields} allowSelection={true}
        editSettings={editOptions} toolbar={toolbar} height = '450px'>
            <Inject services={[Edit, Selection, Toolbar]} />
        </GanttComponent>
};
ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Delete tasks programmatically

Delete tasks programmatically using the deleteRow method, which requires a selected row and Edit. Ensure the row is selected and taskFields mappings (e.g., id) are valid to perform the deletion. This method supports automation, such as removing tasks via a custom button, and respects the confirmation dialog if enabled.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Edit, Selection, Inject } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

function App() {

    let ganttInstance: GanttComponent | null = null;

    const taskData: object[] = [
        { TaskID: 1, TaskName: 'Product concept', StartDate: new Date('04/02/2025'), EndDate: new Date('04/08/2025') },
        { TaskID: 2, TaskName: 'Define the product usage', StartDate: new Date('04/02/2025'), Duration: 1, Progress: 30, ParentID: 1 },
        { TaskID: 3, TaskName: 'Define the target audience', StartDate: new Date('04/02/2025'), Duration: 2, Progress: 40, ParentID: 1 },
        { TaskID: 4, TaskName: 'Prepare product sketch and notes', StartDate: new Date('04/05/2025'), Duration: 2, Progress: 30, ParentID: 1, Predecessor: '2' },
        { TaskID: 5, TaskName: 'Concept approval', StartDate: new Date('04/08/2025'), Duration: 0, ParentID: 1, Predecessor: '3,4' },
        { TaskID: 6, TaskName: 'Market research', StartDate: new Date('04/09/2025'), EndDate: new Date('04/18/2025'), Progress: 30 },
        { TaskID: 7, TaskName: 'Demand analysis', Progress: 40, ParentID: 6 },
        { TaskID: 8, TaskName: 'Customer strength', StartDate: new Date('04/09/2025'), Duration: 4, Progress: 30, ParentID: 7, Predecessor: '5' },
        { TaskID: 9, TaskName: 'Market opportunity analysis', StartDate: new Date('04/09/2025'), Duration: 4, ParentID: 7, Predecessor: '5' },
        { TaskID: 10, TaskName: 'Competitor analysis', StartDate: new Date('04/15/2025'), Duration: 4, Progress: 30, ParentID: 6, Predecessor: '7,8' }
    ];

    const taskFields: object = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        dependency: 'Predecessor',
        progress: 'Progress',
        parentID: 'ParentID'
    };

    const editSettings: object = {
        allowDeleting: true,
        showDeleteConfirmDialog: true
    };

    const deleteTask = (): void => {
        if (!ganttInstance) return;

        const selectedRecords = ganttInstance.selectionModule.getSelectedRecords();
        if (selectedRecords.length) {
            ganttInstance.editModule.deleteRecord(selectedRecords[0].TaskID);
        }
    };

    return (
        <div>
            <ButtonComponent onClick={deleteTask}>Delete Task</ButtonComponent>
            <br /><br />
            <GanttComponent
                id="ganttDefault"
                height="430px"
                dataSource={taskData}
                taskFields={taskFields}
                editSettings={editSettings}
                ref={gantt => ganttInstance = gantt}
            >
                <Inject services={[Edit, Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));

See also

Deleting Tasks in Angular Gantt Chart Component

18 Nov 201821 minutes to read

Deleting tasks in the Angular Gantt Chart component streamlines project management by removing tasks, such as outdated milestones or subtasks, using the toolbar or programmatic methods. Enabled by setting the editSettings.allowDeleting property to true and injecting EditService, tasks can be deleted after selecting a row, ensuring seamless updates to dependencies and critical path calculations. A confirmation dialog, activated via editSettings.showDeleteConfirmDialog, prompts to verify deletions, preventing accidental removals. The deleteRecord method allows programmatic deletion, requiring a selected row with valid taskFields mappings (e.g., id, name). Ensure tasks are selected and taskFields are properly configured to avoid issues during deletion.

Delete tasks via toolbar

Enable task deletion through the toolbar by setting editSettings.allowDeleting to true and injecting EditService. Select a row and click the toolbar’s Delete icon to remove the task, with an optional confirmation dialog if editSettings.showDeleteConfirmDialog is enabled. This method is ideal for quickly removing tasks like completed activities.

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import {
    GanttModule,
    GanttComponent,
    EditService,
    EditSettingsModel,
    SelectionService,
    ToolbarService,
    ToolbarItem
} from '@syncfusion/ej2-angular-gantt';

@Component({
    standalone: true,
    selector: 'app-root',
    imports: [GanttModule, ButtonModule],
    providers: [EditService, SelectionService, ToolbarService],
    encapsulation: ViewEncapsulation.None,
    template: `
    <ejs-gantt
      #gantt
      id="ganttDefault"
      height="430px"
      [dataSource]="data"
      [taskFields]="taskSettings"
      [editSettings]="editSettings"
      [columns]="columns"
      [toolbar]="toolbar"
      [allowSelection]="true">
    </ejs-gantt>
  `
})
export class AppComponent implements OnInit {
    @ViewChild('gantt', { static: true }) public ganttInstance?: GanttComponent;

    public data!: object[];
    public taskSettings!: object;
    public columns!: object[];
    public editSettings!: EditSettingsModel;
    public toolbar: ToolbarItem[] = ['Delete'];

    ngOnInit(): void {
        this.data = [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 2, TaskName: 'Identify Site location', Duration: 3, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Progress: 50 },
                    { TaskID: 4, TaskName: 'Soil test approval', EndDate: new Date('04/08/2019'), Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), EndDate: new Date('04/08/2019'), Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', Duration: 0, Progress: 50 }
                ]
            }
        ];

        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            endDate: 'EndDate',
            duration: 'Duration',
            progress: 'Progress',
            child: 'subtasks'
        };

        this.editSettings = {
            allowDeleting: true,
            showDeleteConfirmDialog: true
        };

        this.columns = [
            { field: 'TaskID', headerText: 'Task ID', width: 100 },
            { field: 'TaskName', headerText: 'Task Name', width: 250 },
            { field: 'StartDate', headerText: 'Start Date', width: 150 },
            { field: 'Duration', headerText: 'Duration', width: 150 },
            { field: 'Progress', headerText: 'Progress', width: 150 }
        ];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Delete tasks with confirmation dialog

Enable a confirmation dialog for task deletion by setting editSettings.showDeleteConfirmDialog to true, alongside editSettings.allowDeleting and EditService. After selecting a row, deleting via the toolbar or deleteRecord method prompts a dialog to confirm the action, ensuring intentional removals. This is useful for critical tasks where accidental deletion must be avoided.

import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { GanttModule, EditService, EditSettingsModel, ToolbarItem, SelectionService, ToolbarService } from '@syncfusion/ej2-angular-gantt'

@Component({
    imports: [GanttModule],
    providers: [EditService, SelectionService, ToolbarService],
    standalone: true,
    selector: 'app-root',
    template:
        `<ejs-gantt height="430px" [dataSource]="data" [taskFields]="taskSettings"  [editSettings]="editSettings" [toolbar]="toolbar" [columns]="columns"></ejs-gantt>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
    public data?: object[];
    public taskSettings?: object;
    public columns?: object[];
    public toolbar?: ToolbarItem[];
    public editSettings?: EditSettingsModel;

    public ngOnInit(): void {
        this.data = [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                isParent: true,
                subtasks: [
                    { TaskID: 2, TaskName: 'Identify Site location', Duration: 3, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Progress: 50 },
                    { TaskID: 4, TaskName: 'Soil test approval', EndDate: new Date('04/08/2019'), Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                isParent: true,
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), EndDate: new Date('04/08/2019'), Progress: 50, resources: [4], isParent: false },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', Duration: 0, Progress: 50 }
                ]
            },
        ];
        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            endDate: 'EndDate',
            duration: 'Duration',
            progress: 'Progress',
            dependency: 'Predecessor',
            child: 'subtasks'
        };
        this.columns = [
            { field: 'TaskID', headerText: 'Task ID', textAlign: 'Left', width: '100' },
            { field: 'TaskName', headerText: 'Task Name', width: '250' },
            { field: 'StartDate', headerText: 'Start Date', width: '150' },
            { field: 'Duration', headerText: 'Duration', width: '150' },
            { field: 'Progress', headerText: 'Progress', width: '150' },
        ];
        this.editSettings = {
            allowDeleting: true,
            showDeleteConfirmDialog: true
        };
        this.toolbar = ['Delete'];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Delete tasks programmatically

Delete tasks programmatically using the deleteRecord method, which requires a selected row and EditService. Ensure the row is selected and taskFields mappings (e.g., id) are valid to perform the deletion. This method supports automation, such as removing tasks via a custom button, and respects the confirmation dialog if enabled.

import { Component, ViewChild } from "@angular/core";
import {
  GanttModule,
  GanttComponent,
  EditService,
  SelectionService,
} from "@syncfusion/ej2-angular-gantt";

@Component({
  imports: [GanttModule],
  providers: [EditService, SelectionService],
  standalone: true,
  selector: "app-root",
  template: ` <button ejs-button (click)="deleteTask()">Delete Task</button>
    <ejs-gantt
      #ganttInstance
      id="ganttDefault"
      height="430px"
      [dataSource]="taskData"
      [taskFields]="taskSettings"
      [editSettings]="editSettings"
    >
    </ejs-gantt>`,
})
export class AppComponent {
  @ViewChild("ganttInstance", { static: true })
  public ganttInstance: GanttComponent;
  public taskData: object[] = [
    {
      TaskID: 1,
      TaskName: "Product concept",
      StartDate: new Date("04/02/2025"),
      EndDate: new Date("04/08/2025"),
    },
    {
      TaskID: 2,
      TaskName: "Define the product usage",
      StartDate: new Date("04/02/2025"),
      EndDate: new Date("04/08/2025"),
      Duration: 1,
      Progress: 30,
      ParentId: 1,
    },
    {
      TaskID: 3,
      TaskName: "Define the target audience",
      StartDate: new Date("04/02/2025"),
      EndDate: new Date("04/04/2025"),
      Duration: 2,
      Progress: 40,
      ParentId: 1,
    },
    {
      TaskID: 4,
      TaskName: "Prepare product sketch and notes",
      StartDate: new Date("04/05/2025"),
      Duration: 2,
      Progress: 30,
      ParentId: 1,
      Predecessor: "2",
    },
    {
      TaskID: 5,
      TaskName: "Concept approval",
      StartDate: new Date("04/08/2025"),
      EndDate: new Date("04/08/2025"),
      Duration: 0,
      ParentId: 1,
      Predecessor: "3,4",
    },
    {
      TaskID: 6,
      TaskName: "Market research",
      StartDate: new Date("04/09/2025"),
      EndDate: new Date("04/18/2025"),
      Progress: 30,
    },
    { TaskID: 7, TaskName: "Demand analysis", Progress: 40, ParentId: 6 },
    {
      TaskID: 8,
      TaskName: "Customer strength",
      StartDate: new Date("04/09/2025"),
      EndDate: new Date("04/12/2025"),
      Duration: 4,
      Progress: 30,
      ParentId: 7,
      Predecessor: "5",
    },
    {
      TaskID: 9,
      TaskName: "Market opportunity analysis",
      StartDate: new Date("04/09/2025"),
      EndDate: new Date("04/12/2025"),
      Duration: 4,
      ParentId: 7,
      Predecessor: "5",
    },
    {
      TaskID: 10,
      TaskName: "Competitor analysis",
      StartDate: new Date("04/15/2025"),
      EndDate: new Date("04/18/2025"),
      Duration: 4,
      Progress: 30,
      ParentId: 6,
      Predecessor: "7,8",
    },
  ];
  public taskSettings: object = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    duration: "Duration",
    dependency: "Predecessor",
    progress: "Progress",
    parentID: "ParentId",
  };

  public editSettings: object = {
    allowDeleting: true,
  };

  public deleteTask(): void {
    this.ganttInstance.deleteRecord(this.ganttInstance.selectedRowIndex + 1);
  }
}

See also